import { Component, Directive, Input, Output, HostListener, HostBinding, EventEmitter, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
var SuiRadioButton = (function () {
    function SuiRadioButton() {
        this._classes = true;
        this.value = "";
        this.isDisabled = false;
        this.isReadonly = false;
        this.isChecked = false;
        this.currentValueChange = new EventEmitter(false);
    }
    Object.defineProperty(SuiRadioButton.prototype, "checkedAttribute", {
        /**
         * @return {?}
         */
        get: function () {
            return this.isChecked ? "" : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiRadioButton.prototype, "isDisabledAttribute", {
        /**
         * @return {?}
         */
        get: function () {
            return this.isDisabled ? "disabled" : null;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    SuiRadioButton.prototype.onClick = function () {
        if (!this.isDisabled && !this.isReadonly) {
            this.currentValue = this.value;
            this.currentValueChange.emit(this.currentValue);
            this.update();
        }
    };
    /**
     * @return {?}
     */
    SuiRadioButton.prototype.update = function () {
        var _this = this;
        //This is a horrible hack - need to rewrite!
        setTimeout(function () {
            _this.isChecked = _this.currentValue == _this.value;
        });
    };
    /**
     * @param {?} value
     * @return {?}
     */
    SuiRadioButton.prototype.writeValue = function (value) {
        this.currentValue = value;
        this.update();
    };
    return SuiRadioButton;
}());
export { SuiRadioButton };
SuiRadioButton.decorators = [
    { type: Component, args: [{
                selector: 'sui-radio-button[ngModel]',
                exportAs: 'suiRadioButton',
                template: "\n<input class=\"hidden\"\n       type=\"checkbox\"\n       [attr.name]=\"name\"\n       [attr.checked]=\"checkedAttribute\"\n       [attr.disabled]=\"isDisabledAttribute\"\n       [ngModel]=\"isChecked\"\n       (ngModel)=\"currentValue = value\">\n<label>\n    <ng-content></ng-content>\n</label>\n"
            },] },
];
/**
 * @nocollapse
 */
SuiRadioButton.ctorParameters = function () { return []; };
SuiRadioButton.propDecorators = {
    '_classes': [{ type: HostBinding, args: ['class.ui',] }, { type: HostBinding, args: ['class.radio',] }, { type: HostBinding, args: ['class.checkbox',] },],
    'name': [{ type: Input },],
    'value': [{ type: Input },],
    'isDisabled': [{ type: Input },],
    'isReadonly': [{ type: HostBinding, args: ['class.read-only',] }, { type: Input },],
    'isChecked': [{ type: HostBinding, args: ['class.checked',] },],
    'currentValueChange': [{ type: Output },],
    'onClick': [{ type: HostListener, args: ['click',] },],
};
function SuiRadioButton_tsickle_Closure_declarations() {
    /** @type {?} */
    SuiRadioButton.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    SuiRadioButton.ctorParameters;
    /** @type {?} */
    SuiRadioButton.propDecorators;
    /** @type {?} */
    SuiRadioButton.prototype._classes;
    /** @type {?} */
    SuiRadioButton.prototype.name;
    /** @type {?} */
    SuiRadioButton.prototype.value;
    /** @type {?} */
    SuiRadioButton.prototype.isDisabled;
    /** @type {?} */
    SuiRadioButton.prototype.isReadonly;
    /** @type {?} */
    SuiRadioButton.prototype.isChecked;
    /** @type {?} */
    SuiRadioButton.prototype.currentValue;
    /** @type {?} */
    SuiRadioButton.prototype.currentValueChange;
}
export var /** @type {?} */ CUSTOM_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(function () { return SuiRadioButtonValueAccessor; }),
    multi: true
};
var SuiRadioButtonValueAccessor = (function () {
    /**
     * @param {?} host
     */
    function SuiRadioButtonValueAccessor(host) {
        this.host = host;
        this.onChange = function () { };
        this.onTouched = function () { };
    }
    /**
     * @param {?} value
     * @return {?}
     */
    SuiRadioButtonValueAccessor.prototype.writeValue = function (value) {
        this.host.writeValue(value);
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    SuiRadioButtonValueAccessor.prototype.registerOnChange = function (fn) { this.onChange = fn; };
    /**
     * @param {?} fn
     * @return {?}
     */
    SuiRadioButtonValueAccessor.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
    return SuiRadioButtonValueAccessor;
}());
export { SuiRadioButtonValueAccessor };
SuiRadioButtonValueAccessor.decorators = [
    { type: Directive, args: [{
                selector: 'sui-radio-button',
                host: { '(currentValueChange)': 'onChange($event)' },
                providers: [CUSTOM_VALUE_ACCESSOR]
            },] },
];
/**
 * @nocollapse
 */
SuiRadioButtonValueAccessor.ctorParameters = function () { return [
    { type: SuiRadioButton, },
]; };
function SuiRadioButtonValueAccessor_tsickle_Closure_declarations() {
    /** @type {?} */
    SuiRadioButtonValueAccessor.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    SuiRadioButtonValueAccessor.ctorParameters;
    /** @type {?} */
    SuiRadioButtonValueAccessor.prototype.onChange;
    /** @type {?} */
    SuiRadioButtonValueAccessor.prototype.onTouched;
    /** @type {?} */
    SuiRadioButtonValueAccessor.prototype.host;
}
export var /** @type {?} */ SUI_RADIOBUTTON_DIRECTIVES = [SuiRadioButton, SuiRadioButtonValueAccessor];
//# sourceMappingURL=radiobutton.js.map