import { Component, Input, Output, HostBinding, HostListener, EventEmitter } from '@angular/core';
var SuiDimmer = (function () {
    function SuiDimmer() {
        this.classes = true;
        this.isClickable = true;
        this.isDimmed = false;
        this.isDimmedChange = new EventEmitter(false);
    }
    /**
     * @return {?}
     */
    SuiDimmer.prototype.click = function () {
        if (this.isClickable) {
            this.isDimmed = false;
            this.isDimmedChange.emit(this.isDimmed);
        }
    };
    return SuiDimmer;
}());
export { SuiDimmer };
SuiDimmer.decorators = [
    { type: Component, args: [{
                selector: 'sui-dimmer',
                exportAs: 'suiDimmer',
                template: "\n<div class=\"content\">\n    <div class=\"center\">\n        <ng-content></ng-content>\n    </div>\n</div>\n",
                styles: ["\n:host.dimmer {\n    transition: visibility 0.3s, opacity 0.3s ease;\n    display: block;\n    visibility: hidden;\n}\n\n:host.active {\n    visibility: visible;\n}\n"]
            },] },
];
/**
 * @nocollapse
 */
SuiDimmer.ctorParameters = function () { return []; };
SuiDimmer.propDecorators = {
    'classes': [{ type: HostBinding, args: ['class.ui',] }, { type: HostBinding, args: ['class.dimmer',] },],
    'isClickable': [{ type: Input },],
    'isDimmed': [{ type: HostBinding, args: ['class.active',] }, { type: Input },],
    'isDimmedChange': [{ type: Output },],
    'click': [{ type: HostListener, args: ['click',] },],
};
function SuiDimmer_tsickle_Closure_declarations() {
    /** @type {?} */
    SuiDimmer.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    SuiDimmer.ctorParameters;
    /** @type {?} */
    SuiDimmer.propDecorators;
    /** @type {?} */
    SuiDimmer.prototype.classes;
    /** @type {?} */
    SuiDimmer.prototype.isClickable;
    /** @type {?} */
    SuiDimmer.prototype.isDimmed;
    /** @type {?} */
    SuiDimmer.prototype.isDimmedChange;
}
export var /** @type {?} */ SUI_DIMMER_DIRECTIVES = [SuiDimmer];
//# sourceMappingURL=dimmer.js.map