import { Component, Input, HostBinding } from '@angular/core';
var SuiProgress = (function () {
    function SuiProgress() {
        this._classes = true;
        this._value = 0;
        this.unscaledValue = 0;
        this._maximum = 100;
        this.autoSuccess = true;
        this.progress = true;
        this.precision = 0;
    }
    Object.defineProperty(SuiProgress.prototype, "reachedMaximum", {
        /**
         * @return {?}
         */
        get: function () {
            return this.value == this.maximum && this.autoSuccess;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiProgress.prototype, "value", {
        /**
         * @return {?}
         */
        get: function () {
            return this._value;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            value = parseFloat(value);
            if (Number.isNaN(value)) {
                return;
            }
            value = Math.max(value, 0);
            //Keep this for when maximum changes
            this.unscaledValue = value;
            value = Math.min(value, this.maximum);
            this._value = parseFloat((value / this.maximum * 100).toFixed(Math.min(20, Math.max(this.precision, 0))));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiProgress.prototype, "maximum", {
        /**
         * @return {?}
         */
        get: function () {
            return this._maximum;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            value = parseFloat(value);
            if (Number.isNaN(value)) {
                return;
            }
            value = Math.max(value, 0);
            this._maximum = value;
            this.value = this.unscaledValue;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiProgress.prototype, "percentage", {
        /**
         * @return {?}
         */
        get: function () {
            return this._value.toString();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiProgress.prototype, "classValue", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value.includes("attached") || value.includes("tiny")) {
                this.progress = false;
            }
        },
        enumerable: true,
        configurable: true
    });
    return SuiProgress;
}());
export { SuiProgress };
SuiProgress.decorators = [
    { type: Component, args: [{
                selector: 'sui-progress',
                exportAs: 'suiProgress',
                template: "\n<div class=\"bar\" [style.width.%]=\"percentage\">\n    <div class=\"progress\" *ngIf=\"progress\">{{ percentage }}%</div>\n</div>\n<div class=\"label\">\n    <ng-content></ng-content>\n</div>\n",
                styles: [".bar { transition-duration: 300ms !important; }"]
            },] },
];
/**
 * @nocollapse
 */
SuiProgress.ctorParameters = function () { return []; };
SuiProgress.propDecorators = {
    '_classes': [{ type: HostBinding, args: ['class.ui',] }, { type: HostBinding, args: ['class.progress',] },],
    'reachedMaximum': [{ type: HostBinding, args: ['class.success',] },],
    'autoSuccess': [{ type: Input },],
    'progress': [{ type: Input },],
    'precision': [{ type: Input },],
    'value': [{ type: Input },],
    'maximum': [{ type: Input },],
    'percentage': [{ type: HostBinding, args: ['attr.data-percent',] },],
    'classValue': [{ type: Input, args: ['class',] },],
};
function SuiProgress_tsickle_Closure_declarations() {
    /** @type {?} */
    SuiProgress.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    SuiProgress.ctorParameters;
    /** @type {?} */
    SuiProgress.propDecorators;
    /** @type {?} */
    SuiProgress.prototype._classes;
    /** @type {?} */
    SuiProgress.prototype._value;
    /** @type {?} */
    SuiProgress.prototype.unscaledValue;
    /** @type {?} */
    SuiProgress.prototype._maximum;
    /** @type {?} */
    SuiProgress.prototype.autoSuccess;
    /** @type {?} */
    SuiProgress.prototype.progress;
    /** @type {?} */
    SuiProgress.prototype.precision;
}
export var /** @type {?} */ SUI_PROGRESS_DIRECTIVES = [SuiProgress];
//# sourceMappingURL=progress.js.map