import { AfterViewInit, EventEmitter, ElementRef } from '@angular/core';
import { DropdownService } from '../dropdown/dropdown.service';
import { ControlValueAccessor } from '@angular/forms';
import { SearchService, LookupFn } from './search.service';
export declare class SuiSearch<T> implements AfterViewInit {
    private _element;
    dropdownService: DropdownService;
    searchService: SearchService<T>;
    private _menu;
    private _searchClasses;
    readonly isActive: boolean;
    hasIcon: boolean;
    placeholder: string;
    query: string;
    options: T[] | LookupFn<T>;
    optionsField: string;
    searchDelay: number;
    readonly isSearching: boolean;
    readonly results: T[];
    selectedItem: T;
    onItemSelected: EventEmitter<T>;
    readonly ngModelChange: EventEmitter<T>;
    constructor(_element: ElementRef);
    ngAfterViewInit(): void;
    select(item: T): void;
    onClick(e: MouseEvent): void;
    readValue(object: T): string;
    writeValue(item: T): void;
}
export declare const SEARCH_VALUE_ACCESSOR: any;
export declare class SuiSearchValueAccessor<T> implements ControlValueAccessor {
    private host;
    onChange: () => void;
    onTouched: () => void;
    constructor(host: SuiSearch<T>);
    writeValue(value: T): void;
    registerOnChange(fn: () => void): void;
    registerOnTouched(fn: () => void): void;
}
