import { ElementRef, Renderer, EventEmitter, AfterViewInit } from '@angular/core';
import { SuiSelectBase } from './select-base';
import { ControlValueAccessor } from '@angular/forms';
export declare class SuiMultiSelect<T, U> extends SuiSelectBase<T, U> implements AfterViewInit {
    selectedOptions: T[];
    private _writtenOptions;
    private _renderedSelectedOptions;
    private _renderedSelectedSubscriptions;
    selectedOptionsChange: EventEmitter<U[]>;
    readonly ngModelChange: EventEmitter<U[]>;
    protected optionsUpdateHook(): void;
    readonly availableOptions: T[];
    maxSelected: number;
    readonly maxSelectedReached: boolean;
    private _multiSelectClasses;
    constructor(element: ElementRef, renderer: Renderer);
    selectOption(option: T): void;
    writeValues(values: U[]): void;
    deselectOption(option: T): void;
    onQueryInputKeydown(event: KeyboardEvent): void;
    ngAfterViewInit(): void;
    private onSelectedOptionsRendered();
}
export declare const MULTI_SELECT_VALUE_ACCESSOR: any;
export declare class SuiMultiSelectValueAccessor<T, U> implements ControlValueAccessor {
    private host;
    onChange: () => void;
    onTouched: () => void;
    constructor(host: SuiMultiSelect<T, U>);
    writeValue(value: U[]): void;
    registerOnChange(fn: () => void): void;
    registerOnTouched(fn: () => void): void;
}
