import { EventEmitter, ElementRef, Renderer } from '@angular/core';
import { SuiSelectBase } from './select-base';
import { ControlValueAccessor } from '@angular/forms';
import { ISelectRenderedOption } from './select-option';
export declare type SingleItemLookup<T, U> = (query: string, initial?: U) => Promise<T>;
export declare class SuiSelect<T, U> extends SuiSelectBase<T, U> {
    selectedOption: T;
    private _writtenOption;
    private _optionTemplateSibling;
    selectedOptionChange: EventEmitter<U>;
    readonly ngModelChange: EventEmitter<U>;
    protected optionsUpdateHook(): void;
    protected queryUpdateHook(): void;
    constructor(element: ElementRef, renderer: Renderer);
    selectOption(option: T): void;
    writeValue(value: U): void;
    protected initialiseRenderedOption(option: ISelectRenderedOption<T>): void;
    private drawSelectedOption();
}
export declare const SELECT_VALUE_ACCESSOR: any;
export declare class SuiSelectValueAccessor<T, U> implements ControlValueAccessor {
    private host;
    onChange: () => void;
    onTouched: () => void;
    constructor(host: SuiSelect<T, U>);
    writeValue(value: U): void;
    registerOnChange(fn: () => void): void;
    registerOnTouched(fn: () => void): void;
}
